#if !defined(FO_MYCORSSSLINESHAPE_H__5275D660_0F0D_11D6_A50C_525400EA266C__INCLUDED_)
#define AFC_MYCORSSSLINESHAPE_H__5275D660_0F0D_11D6_A50C_525400EA266C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//------------------------------------------------------
// Shape.
//------------------------------------------------------


#include "FODrawPortsShape.h"
#include "MyCustomProperties.h"
 
#define MY_LINE_TYPE   FO_COMP_CUSTOM + 1

class CMyCorsssLineShape : public CFODrawPortsShape  
{
protected:
	DECLARE_SERIAL(CMyCorsssLineShape);
public:

	// constructor
	CMyCorsssLineShape();

	// Copy constructor.
	CMyCorsssLineShape(const CMyCorsssLineShape& src);

	// Destructor.
	virtual ~CMyCorsssLineShape();

	// Creates the button shape from a CRect object.
	virtual void Create(CRect &rcPos,CString strCaption = "");

public:

	// Return the default property.
	CMyCustomProperties *GetLineProperty() const;

	void	SetDescription(const CString strText);
	CString	GetDescription() const;

public:

	// Assignment operator.
	CMyCorsssLineShape& operator=(const CMyCorsssLineShape& src);

	// Creates a copy of this shape.
	virtual CFODrawShape* Copy() const;

	virtual void GeometryUpdated(CFOArea* pRgn);

	// Rotate shape.
	virtual void RotateShape(int nAngle, float fOX, float fOY);

	// Rotate shape.
	virtual void RotateTrackShape(int nAngle, float fOX, float fOY);

public:

	// Serializes the data.
	virtual void Serialize(CArchive &ar);
	
	// Save document.
	virtual BOOL SaveDocument(LPCTSTR lpszPathName);

	// Open document.
	virtual BOOL OpenDocument(LPCTSTR lpszPathName);
	
	// Get file.
	CFile *GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,CFileException* pError);
	
	// Release file.
	virtual void ReleaseFile(CFile* pFile, BOOL bAbort);

public:

	//Draw flat status.

	// Draws custom tracker.
	virtual void OnDrawTrackCustom(CDC *pDC);

	// Creates GDI objects and sets up the device context for drawing. 
	virtual void PrepareDC(CDC* pDC);

	// Draws the flat status of the shape.
	virtual void OnDrawFlat(CDC *pDC);

	// Draws shadow of shape.
	virtual void OnDrawShadow(CDC *pDC);

	// Draws the 3D status of the shape.
	virtual void OnDraw3d(CDC *pDC);

	// Frees GDI objects and restores the state of the device context.
	virtual void ClearDC(CDC* pDC);
	// Implementation

public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
	// Set the properties of the shape.
	virtual void OnCustomProperties();
};


#endif // !defined(AFC_MYCORSSSLINESHAPE_H__5275D660_0F0D_11D6_A50C_525400EA266C__INCLUDED_)
