// MyCustomProperties.cpp: implementation of the CMyCustomProperties class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "custommsample.h"
#include "MyCustomProperties.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// CMyCustomProperties construction/destruction

IMPLEMENT_SERIAL(CMyCustomProperties, CFOBaseProperties,1)

//mfunc | CMyCustomProperties | CMyCustomProperties | Constructor.

CMyCustomProperties::CMyCustomProperties(int nCurID) : CFOBaseProperties(nCurID)
{
	m_strDescription = "";
}

CMyCustomProperties::CMyCustomProperties(const CMyCustomProperties& propShape) 
	: CFOBaseProperties(propShape.GetPropId())
{
	m_strDescription = propShape.GetDescription();
}

//mfunc Destructor.
CMyCustomProperties::~CMyCustomProperties()
{
}

//The property to copy.
CMyCustomProperties& CMyCustomProperties::operator=(const CMyCustomProperties& propShape)
{
	m_strDescription = propShape.GetDescription();
	return *this;
}

BOOL CMyCustomProperties::IsEqual(CFOBaseProperties* prop)
{
	if (GetPropId() == prop->GetPropId())
	{
		CMyCustomProperties* pProp = (CMyCustomProperties*)prop;

		if (pProp)
			return (*this == *pProp);
	}

	return FALSE;
}

BOOL CMyCustomProperties::operator==(const CMyCustomProperties propEdit) const
{
	if(GetDescription() == propEdit.GetDescription())
	{
		return TRUE;
	}
	
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////
// CMyCustomProperties serialization
void CMyCustomProperties::Serialize(CArchive& ar)
{
	CFOBaseProperties::Serialize(ar);

	if (ar.IsStoring())
	{
		ar << m_strDescription;
	}
	else
	{
		ar >> m_strDescription;
	}
}


/////////////////////////////////////////////////////////////////////////////
// CMyCustomProperties diagnostics

#ifdef _DEBUG
void CMyCustomProperties::AssertValid() const
{
	CFOBaseProperties::AssertValid();
}

void CMyCustomProperties::Dump(CDumpContext& dc) const
{
	CFOBaseProperties::Dump(dc);
}
#endif //_DEBUG


BOOL CMyCustomProperties::PutValue(const int &nPropId,const FO_VALUE &value)
{
	BOOL bReturn = TRUE;
	switch(nPropId)
	{
	case M_ID_DESCRIPTION:
		{
			SetDescription(value.m_strValue);
		}
		break;
		
	default:
		{
			bReturn = FALSE;
		}
		break;
		
	}


	return bReturn;
}

BOOL CMyCustomProperties::GetValue(FO_VALUE &value,const int &nPropId)
{
	BOOL bReturn = TRUE;
	switch(nPropId)
	{
	case M_ID_DESCRIPTION:
		{
			value.m_nValueType = V_STRING;
			value.m_strValue = GetDescription();
		}
		break;
		
	default:
		{
			bReturn = FALSE;
		}
		break;
		
	}


	return bReturn;
}

