// MyCustomProperties.h: interface for the CMyCustomProperties class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYCUSTOMPROPERTIES_H__7E087801_BAB9_11D5_A479_525400EA266C__INCLUDED_)
#define AFX_MYCUSTOMPROPERTIES_H__7E087801_BAB9_11D5_A479_525400EA266C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//------------------------------------------------------
// Properties.
//------------------------------------------------------

#define FO_MY_PROP_ID  FO_CUSTOM_PROP_ID +1

#define M_ID_DESCRIPTION		5001

class CMyCustomProperties : public CFOBaseProperties
{
	DECLARE_SERIAL(CMyCustomProperties)

// Construction/Destruction
public:

	// Constructor with ID.
	CMyCustomProperties(int nCurID = FO_MY_PROP_ID);
	
	// Copy constructor. 
	CMyCustomProperties(const CMyCustomProperties& propShape);
	
	// Destructor. 
	virtual ~CMyCustomProperties();

	// Create a copy of properties.
	virtual CFOBaseProperties* Copy();

	// Is equal.
	virtual BOOL IsEqual(CFOBaseProperties* prop);

public:

	// Put value.
	virtual BOOL PutValue(const int &nPropId,const FO_VALUE &Value);

	// Get value.
	virtual BOOL GetValue(FO_VALUE &Value,const int &nPropId);

public:
	void	SetDescription(const CString strText)	{ m_strDescription = strText; }
	CString	GetDescription() const					{ return m_strDescription; }

// Attributes
protected:
	
	// FODO:Add your properties items below.
	
	// Custom properties.
	CString m_strDescription;
public:

	
	// Sets this set of font properties equal to another. 
	CMyCustomProperties& operator=(const CMyCustomProperties& propEdit);

	// Determines if another set of fill properties is equal to this one. 
	BOOL operator==(const CMyCustomProperties propEdit) const;

	virtual void Serialize(CArchive& ar);

// Implementation
public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
inline CFOBaseProperties* CMyCustomProperties::Copy()
{
	return new CMyCustomProperties(*this);
}

#endif // !defined(AFX_MYCUSTOMPROPERTIES_H__7E087801_BAB9_11D5_A479_525400EA266C__INCLUDED_)
