// MyDataModelManager.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MyDataModelManager.h"
#include "MyExtDataModel.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyDataModelManager construction/destruction

IMPLEMENT_SERIAL(CMyDataModelManager, CFOMultiPageModelManager, 0)
CMyDataModelManager::CMyDataModelManager()
{
	//FOTO:Add you code here.
}

CMyDataModelManager::~CMyDataModelManager()
{
	//FOTO:Add you code here.

}

void CMyDataModelManager::ClearAll()
{
	CFOMultiPageModelManager::ClearAll();
	//FOTO:Add you code here.

}

CFOMultiPageModel *CMyDataModelManager::AddNewModel(CString strCaption)
{
	int nPageNumber = GetUniquePageNumber();
	if(strCaption.IsEmpty())
	{
		strCaption = GetUniquePageCaption();
	}
	CMyExtDataModel *pModel = new CMyExtDataModel;
	pModel->SetPageItemCaption(strCaption);
	pModel->SetPageItemNumber( nPageNumber );
	pModel->SetPageItemSelected(TRUE);
	m_ModelList.AddTail(pModel);
	ChangeModel(pModel->GetPageItemNumber());
	SetModifiedFlag();
	return pModel;
}

void CMyDataModelManager::Serialize(CArchive& ar)
{
	CFOMultiPageModelManager::Serialize(ar);
	if(ar.IsStoring())
	{
		//FOTO:Add you code here.

	}
	else
	{
		//FOTO:Add you code here.

	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CMyDataModelManager::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
							 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CMyDataModelManager::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CMyDataModelManager::OpenDocument(LPCTSTR lpszPathName)
{
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}

BOOL CMyDataModelManager::SaveDocument(LPCTSTR lpszPathName)
{
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
	return TRUE;        // success
}

/////////////////////////////////////////////////////////////////////////////
// CMyDataModelManager diagnostics

#ifdef _DEBUG
void CMyDataModelManager::AssertValid() const
{
	CFOMultiPageModelManager::AssertValid();
}

void CMyDataModelManager::Dump(CDumpContext& dc) const
{
	CFOMultiPageModelManager::Dump(dc);
}
#endif //_DEBUG
